Projects - Create
Queues a project to be created. Use the GetOperation to periodically check for create project status.
POST https://dev.azure.com/{organization}/_apis/projects?api-version=5.0
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
|
organization
|
path | True |
|
The name of the Azure DevOps organization. |
|
api-version
|
query | True |
|
Version of the API to use. This should be set to '5.0' to use this version of the api. |
Request Body
| Name | Type | Description |
|---|---|---|
| _links |
The links to other objects related to this object. |
|
| abbreviation |
|
Project abbreviation. |
| capabilities |
|
Set of capabilities this project has (such as process template & version control). |
| defaultTeam |
The shallow ref to the default team. |
|
| defaultTeamImageUrl |
|
Url to default team identity image. |
| description |
|
The project's description (if any). |
| id |
|
Project identifier. |
| name |
|
Project name. |
| revision |
|
Project revision. |
| state |
Project state. |
|
| url |
|
Url to the full version of the object. |
| visibility |
Project visibility. |
Responses
| Name | Type | Description |
|---|---|---|
| 200 OK |
successful operation |
Security
oauth2
Type:
oauth2
Flow:
accessCode
Authorization URL:
https://app.vssps.visualstudio.com/oauth2/authorize&response_type=Assertion
Token URL:
https://app.vssps.visualstudio.com/oauth2/token?client_assertion_type=urn:ietf:params:oauth:client-assertion-type:jwt-bearer&grant_type=urn:ietf:params:oauth:grant-type:jwt-bearer
Scopes
| Name | Description |
|---|---|
| vso.project_manage | Grants the ability to create, read, update, and delete projects and teams. |
Examples
Sample Request
POST https://dev.azure.com/fabrikam/_apis/projects?api-version=5.0
{
"name": "FabrikamTravel",
"description": "Frabrikam travel app for Windows Phone",
"capabilities": {
"versioncontrol": {
"sourceControlType": "Git"
},
"processTemplate": {
"templateTypeId": "6b724908-ef14-45cf-84f8-768b5384da45"
}
}
}
Sample Response
{
"id": "066488b8-b14e-43d1-befc-a2e655266e2b",
"status": "queued",
"url": "https://dev.azure.com/fabrikam/_apis/operations/066488b8-b14e-43d1-befc-a2e655266e2b"
}
Definitions
|
Operation |
Reference for an async operation. |
|
Operation |
The current status of the operation. |
|
Project |
The current state of the project. |
|
Project |
Indicates whom the project is visible to. |
|
Reference |
The class to represent a collection of REST reference links. |
|
Team |
Represents a Team Project object. |
|
Web |
OperationReference
Reference for an async operation.
| Name | Type | Description |
|---|---|---|
| id |
|
Unique identifier for the operation. |
| pluginId |
|
Unique identifier for the plugin. |
| status |
The current status of the operation. |
|
| url |
|
URL to get the full operation object. |
OperationStatus
The current status of the operation.
| Name | Type | Description |
|---|---|---|
| cancelled |
|
The operation was cancelled by the user. |
| failed |
|
The operation completed with a failure. |
| inProgress |
|
The operation is in progress. |
| notSet |
|
The operation does not have a status set. |
| queued |
|
The operation has been queued. |
| succeeded |
|
The operation completed successfully. |
ProjectState
The current state of the project.
| Name | Type | Description |
|---|---|---|
| all |
|
All projects regardless of state. |
| createPending |
|
Project has been queued for creation, but the process has not yet started. |
| deleted |
|
Project has been deleted. |
| deleting |
|
Project is in the process of being deleted. |
| new |
|
Project is in the process of being created. |
| unchanged |
|
Project has not been changed. |
| wellFormed |
|
Project is completely created and ready to use. |
ProjectVisibility
Indicates whom the project is visible to.
| Name | Type | Description |
|---|---|---|
| private |
|
The project is only visible to users with explicit access. |
| public |
|
The project is visible to all. |
ReferenceLinks
The class to represent a collection of REST reference links.
| Name | Type | Description |
|---|---|---|
| links |
|
The readonly view of the links. Because Reference links are readonly, we only want to expose them as read only. |
TeamProject
Represents a Team Project object.
| Name | Type | Description |
|---|---|---|
| _links |
The links to other objects related to this object. |
|
| abbreviation |
|
Project abbreviation. |
| capabilities |
|
Set of capabilities this project has (such as process template & version control). |
| defaultTeam |
The shallow ref to the default team. |
|
| defaultTeamImageUrl |
|
Url to default team identity image. |
| description |
|
The project's description (if any). |
| id |
|
Project identifier. |
| name |
|
Project name. |
| revision |
|
Project revision. |
| state |
Project state. |
|
| url |
|
Url to the full version of the object. |
| visibility |
Project visibility. |
WebApiTeamRef
| Name | Type | Description |
|---|---|---|
| id |
|
Team (Identity) Guid. A Team Foundation ID. |
| name |
|
Team name |
| url |
|
Team REST API Url |